pydo.agent.chat.completions.create()
Generated on 8 May 2026
from pydo version
v0.34.0
Usage
client.agent.chat.completions.create(
model="llama3.3-70b-instruct",
messages=[
{"role": "user", "content": "What is the capital of Portugal?"},
],
)Agent inference methods authenticate with an agent access key and require a per-agent endpoint URL:
client = Client(
token=os.environ.get("AGENT_ACCESS_KEY"),
agent_endpoint="https://$AGENT_URL",
)Description
Creates a model response for the given chat conversation via a customer-provisioned agent endpoint.
Parameters
messagesarray of objects requiredA list of messages comprising the conversation so far.
Show child properties
rolestring requiredThe role of the message author.
contentstring or null optionalExample:
Hello, how are you?The contents of the message.
refusalstring or null optionalThe refusal message generated by the model (assistant messages only).
tool_callsarray of objects optionalThe tool calls generated by the model (assistant messages only).
Show child properties
idstring requiredExample:
call_abc123The ID of the tool call.
typestring requiredExample:
functionThe type of the tool. Currently, only function is supported.
functionobject requiredShow child properties
namestring requiredExample:
get_weatherThe name of the function to call.
argumentsstring requiredExample:
{"location": "Boston"}The arguments to call the function with, as generated by the model in JSON format.
tool_call_idstring optionalExample:
call_abc123Tool call that this message is responding to (tool messages only).
reasoning_contentstring or null optionalThe reasoning content generated by the model (assistant messages only).
modelstring requiredExample:
llama3-8b-instructModel ID used to generate the response.
max_tokensinteger or null optionalThe maximum number of tokens that can be generated in the completion. The token count of your prompt plus max_tokens cannot exceed the model's context length.
max_completion_tokensinteger or null optionalThe maximum number of completion tokens that may be used over the course of the run. The run will make a best effort to use only the number of completion tokens specified, across multiple turns of the run.
frequency_penaltynumber or null optionalNumber between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.
presence_penaltynumber or null optionalNumber between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.
top_logprobsinteger or null optionalAn integer between 0 and 20 specifying the number of most likely tokens to return at each token position, each with an associated log probability. logprobs must be set to true if this parameter is used.
toolsarray of objects optionalA list of tools the model may call. Currently, only functions are supported as a tool.
Show child properties
typestring requiredExample:
functionThe type of the tool. Currently, only function is supported.
functionobject requiredShow child properties
namestring requiredExample:
get_weatherThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
descriptionstring optionalExample:
Get the current weather for a location.A description of what the function does, used by the model to choose when and how to call the function.
parametersobject optionalThe parameters the function accepts, described as a JSON Schema object.
tool_choiceobject optionalControls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools. Specifying a particular tool via {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool. none is the default when no tools are present. auto is the default if tools are present.
Show child properties
typestring requiredExample:
functionfunctionobject requiredShow child properties
namestring requiredExample:
get_weatherThe name of the function to call.
streamboolean or null optionalIf set to true, the model response data will be streamed to the client as it is generated using server-sent events.
stopobject optionalUp to 4 sequences where the API will stop generating further tokens. The returned text will not contain the stop sequence.
logit_biasobject or null optionalModify the likelihood of specified tokens appearing in the completion. Accepts a JSON object that maps tokens (specified by their token ID in the tokenizer) to an associated bias value from -100 to 100. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token.
logprobsboolean or null optionalWhether to return log probabilities of the output tokens or not. If true, returns the log probabilities of each output token returned in the content of message.
ninteger or null optionalExample:
1How many chat completion choices to generate for each input message. Note that you will be charged based on the number of generated tokens across all of the choices. Keep n as 1 to minimize costs.
stream_optionsobject or null optionalOptions for streaming response. Only set this when you set stream to true.
Show child properties
include_usageboolean optionalIf set, an additional chunk will be streamed before the data [DONE] message. The usage field on this chunk shows the token usage statistics for the entire request, and the choices field will always be an empty array.
reasoning_effortstring or null optionalConstrains effort on reasoning for reasoning models. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response.
seedinteger or null optionalIf specified, the system will make a best effort to sample deterministically, such that repeated requests with the same seed and parameters should return the same result. Determinism is not guaranteed.
metadataobject or null optionalSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
temperaturenumber or null optionalExample:
1What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. We generally recommend altering this or top_p but not both.
top_pnumber or null optionalExample:
1An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered. We generally recommend altering this or temperature but not both.
userstring optionalExample:
user-1234A unique identifier representing your end-user, which can help DigitalOcean to monitor and detect abuse.
Request Sample
Response Example
More Information
See /api/v1/chat/completions in the API reference for additional detail on responses, headers, parameters, and more.